/*
 * $Id$
 *
 * File is automatically generated by the Xtext language generator.
 * Do not change it.
 *
 * SARL is an general-purpose agent programming language.
 * More details on http://www.sarl.io
 *
 * Copyright 2014-2016 the original authors and authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.sarl.lang.codebuilder.appenders;

import io.sarl.lang.codebuilder.builders.IAnnotationFieldBuilder;
import io.sarl.lang.codebuilder.builders.IAnnotationTypeBuilder;
import io.sarl.lang.sarl.SarlAnnotationType;
import io.sarl.lang.sarl.SarlScript;
import java.io.IOException;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.xbase.compiler.ISourceAppender;
import org.eclipse.xtext.xbase.lib.Pure;

/** Source adapter of a Sarl SarlAnnotationType.
 */
@SuppressWarnings("all")
public class AnnotationTypeSourceAppender extends AbstractSourceAppender implements IAnnotationTypeBuilder {

	private final IAnnotationTypeBuilder builder;

	public AnnotationTypeSourceAppender(IAnnotationTypeBuilder builder) {
		this.builder = builder;
	}

	public void build(ISourceAppender appender) throws IOException {
		build(this.builder.getSarlAnnotationType(), appender);
	}

	private SarlAnnotationType sarlAnnotationType;

	/** Initialize the Ecore element.
	 */
	public void eInit(SarlScript script, String name) {
		this.builder.eInit(script, name);
	}

	/** Replies the generated SarlAnnotationType.
	 */
	@Pure
	public SarlAnnotationType getSarlAnnotationType() {
		return this.builder.getSarlAnnotationType();
	}

	/** Replies the resource to which the SarlAnnotationType is attached.
	 */
	@Pure
	public Resource eResource() {
		return getSarlAnnotationType().eResource();
	}

	/** Change the documentation of the element.
	 *
	 * <p>The documentation will be displayed just before the element.
	 *
	 * @param doc the documentation.
	 */
	public void setDocumentation(String doc) {
		this.builder.setDocumentation(doc);
	}

	/** Add an annotation.
	 * @param type - the qualified name of the annotation.
	 */
	public void addAnnotation(String type) {
		this.builder.addAnnotation(type);
	}

	/** Add a modifier.
	 * @param modifier - the modifier to add.
	 */
	public void addModifier(String modifier) {
		this.builder.addModifier(modifier);
	}

	/** Create an AnnotationField.
	 * @param name - the name of the AnnotationField.
	 * @return the builder.
	 */
	public IAnnotationFieldBuilder addVarAnnotationField(String name) {
		return this.builder.addVarAnnotationField(name);
	}

	/** Create an AnnotationField.
	 * @param name - the name of the AnnotationField.
	 * @return the builder.
	 */
	public IAnnotationFieldBuilder addValAnnotationField(String name) {
		return this.builder.addValAnnotationField(name);
	}

	/** Create an AnnotationField.	 *
	 * <p>This function is equivalent to {@link #addVarAnnotationField}.
	 * @param name - the name of the AnnotationField.
	 * @return the builder.
	 */
	public IAnnotationFieldBuilder addAnnotationField(String name) {
		return this.builder.addAnnotationField(name);
	}

}

