/*
 * $Id$
 *
 * File is automatically generated by the Xtext language generator.
 * Do not change it.
 *
 * SARL is an general-purpose agent programming language.
 * More details on http://www.sarl.io
 *
 * Copyright 2014-2016 the original authors and authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.sarl.lang.codebuilder.appenders;

import io.sarl.lang.codebuilder.builders.IEnumBuilder;
import io.sarl.lang.codebuilder.builders.IXtendEnumLiteralBuilder;
import io.sarl.lang.sarl.SarlEnumeration;
import io.sarl.lang.sarl.SarlScript;
import java.io.IOException;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.xbase.compiler.ISourceAppender;
import org.eclipse.xtext.xbase.lib.Pure;

/** Source adapter of a Sarl SarlEnumeration.
 */
@SuppressWarnings("all")
public class EnumSourceAppender extends AbstractSourceAppender implements IEnumBuilder {

	private final IEnumBuilder builder;

	public EnumSourceAppender(IEnumBuilder builder) {
		this.builder = builder;
	}

	public void build(ISourceAppender appender) throws IOException {
		build(this.builder.getSarlEnumeration(), appender);
	}

	private SarlEnumeration sarlEnumeration;

	/** Initialize the Ecore element.
	 */
	public void eInit(SarlScript script, String name) {
		this.builder.eInit(script, name);
	}

	/** Replies the generated SarlEnumeration.
	 */
	@Pure
	public SarlEnumeration getSarlEnumeration() {
		return this.builder.getSarlEnumeration();
	}

	/** Replies the resource to which the SarlEnumeration is attached.
	 */
	@Pure
	public Resource eResource() {
		return getSarlEnumeration().eResource();
	}

	/** Change the documentation of the element.
	 *
	 * <p>The documentation will be displayed just before the element.
	 *
	 * @param doc the documentation.
	 */
	public void setDocumentation(String doc) {
		this.builder.setDocumentation(doc);
	}

	/** Add an annotation.
	 * @param type - the qualified name of the annotation.
	 */
	public void addAnnotation(String type) {
		this.builder.addAnnotation(type);
	}

	/** Add a modifier.
	 * @param modifier - the modifier to add.
	 */
	public void addModifier(String modifier) {
		this.builder.addModifier(modifier);
	}

	/** Create a XtendEnumLiteral.
	 * @param name - the name of the XtendEnumLiteral.
	 * @return the builder.
	 */
	public IXtendEnumLiteralBuilder addXtendEnumLiteral(String name) {
		return this.builder.addXtendEnumLiteral(name);
	}

}

