/*
 * $Id$
 *
 * File is automatically generated by the Xtext language generator.
 * Do not change it.
 *
 * SARL is an general-purpose agent programming language.
 * More details on http://www.sarl.io
 *
 * Copyright 2014-2016 the original authors and authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.sarl.lang.codebuilder.builders;

import io.sarl.lang.sarl.SarlCapacity;
import io.sarl.lang.sarl.SarlScript;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtext.xbase.lib.Pure;

/** Builder of a Sarl SarlCapacity.
 */
@SuppressWarnings("all")
public interface ICapacityBuilder {

	/** Initialize the Ecore element.
	 */
	void eInit(SarlScript script, String name);

	/** Replies the generated SarlCapacity.
	 */
	@Pure
	SarlCapacity getSarlCapacity();

	/** Replies the resource to which the SarlCapacity is attached.
	 */
	@Pure
	Resource eResource();

	/** Change the documentation of the element.
	 *
	 * <p>The documentation will be displayed just before the element.
	 *
	 * @param doc the documentation.
	 */
	void setDocumentation(String doc);

	/** Add the super type.
	 * @param superType - the qualified name of the super type.
	 */
	void addExtends(String superType);

	/** Add an annotation.
	 * @param type - the qualified name of the annotation.
	 */
	void addAnnotation(String type);

	/** Add a modifier.
	 * @param modifier - the modifier to add.
	 */
	void addModifier(String modifier);

	/** Create an Action.
	 * @param name - the name of the Action.
	 * @return the builder.
	 */
	IActionBuilder addAction(String name);

}

