/*
 * $Id$
 *
 * File is automatically generated by the Xtext language generator.
 * Do not change it.
 *
 * SARL is an general-purpose agent programming language.
 * More details on http://www.sarl.io
 *
 * Copyright 2014-2016 the original authors and authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.sarl.lang.codebuilder.builders;

import java.util.function.Predicate;
import javax.inject.Inject;
import javax.inject.Provider;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtend.core.xtend.XtendEnumLiteral;
import org.eclipse.xtend.core.xtend.XtendFactory;
import org.eclipse.xtend.core.xtend.XtendTypeDeclaration;
import org.eclipse.xtext.util.Strings;
import org.eclipse.xtext.xbase.compiler.DocumentationAdapter;
import org.eclipse.xtext.xbase.lib.Pure;

/** Builder of a Sarl XtendEnumLiteral.
 */
@SuppressWarnings("all")
public class XtendEnumLiteralBuilderImpl extends AbstractBuilder implements IXtendEnumLiteralBuilder {

	@Inject
	private Provider<IFormalParameterBuilder> parameterProvider;
	@Inject
	private Provider<IBlockExpressionBuilder> blockExpressionProvider;
	@Inject
	private Provider<IExpressionBuilder> expressionProvider;
	private EObject container;

	private XtendEnumLiteral xtendEnumLiteral;

	/** Initialize the Ecore element.
	 * @param container - the container of the XtendEnumLiteral.
	 * @param name - the name of the XtendEnumLiteral.
	 */
	public void eInit(XtendTypeDeclaration container, String name) {
		if (this.xtendEnumLiteral == null) {
			this.container = container;
			this.xtendEnumLiteral = XtendFactory.eINSTANCE.createXtendEnumLiteral();
			this.xtendEnumLiteral.setName(name);
			container.getMembers().add(this.xtendEnumLiteral);
		}
	}

	/** Replies the generated element.
	 */
	@Pure
	public XtendEnumLiteral getXtendEnumLiteral() {
		return this.xtendEnumLiteral;
	}

	/** Replies the resource.
	 */
	@Pure
	public Resource eResource() {
		return getXtendEnumLiteral().eResource();
	}

	/** Change the documentation of the element.
	 *
	 * <p>The documentation will be displayed just before the element.
	 *
	 * @param doc the documentation.
	 */
	public void setDocumentation(String doc) {
		if (Strings.isEmpty(doc)) {
			getXtendEnumLiteral().eAdapters().removeIf(new Predicate<Adapter>() {
				public boolean test(Adapter adapter) {
					return adapter.isAdapterForType(DocumentationAdapter.class);
				}
			});
		} else {
			DocumentationAdapter adapter = (DocumentationAdapter) EcoreUtil.getExistingAdapter(
					getXtendEnumLiteral(), DocumentationAdapter.class);
			if (adapter == null) {
				adapter = new DocumentationAdapter();
				getXtendEnumLiteral().eAdapters().add(adapter);
			}
			adapter.setDocumentation(doc);
		}
	}

}

